﻿function GetPluginSettings()
{
    return {
        "name": "Vinoos IAP",
        "id": "VinoosIAP",
        "version": "1.0.0",
        "description":	"Vinoos plugin for In-App Purchases",
        "author": "Vinoos",
        "help url": "http://vinoos.ir/help/plugins/iap.php",
        "category": "Vinoos",
        "type": "object",
        "rotatable": false,
        "cordova-plugins": "https://github.com/vinoosir/vinoos-cordova-iap",
        "flags": 0 | pf_singleglobal

    };
};

//////////////////////////////////////
// Conditions
	AddCondition(0, cf_trigger, "اگر آماده سازی انجام شد", "initialize", "اگر آماده سازی انجام شد", "هنگامی که آماده سازی پلاگین با موفقیت انجام شود", "OnInitializeSuccess");
	AddCondition(1, cf_trigger, "اگر آماده سازی انجام نشد", "initialize", "اگر آماده سازی انجام نشد", "هنگامی که خطایی در آماده سازی پلاگین رخ دهد", "OnInitializeFailed");
	AddCondition(2, cf_trigger, "اگر دریافت اطلاعات محصولات انجام شد", "details", "اگر دریافت اطلاعات محصولات انجام شد", "هنگامی که عملیات دریافت اطلاعات محصولات با موفقیت انجام شود", "OnGetDetailsSuccess");
	AddCondition(3, cf_trigger, "اگر دریافت اطلاعات محصولات انجام نشد", "details", "اگر دریافت اطلاعات محصولات انجام نشد", "هنگامی که خطایی در عملیات دریافت اطلاعات محصولات رخ دهد.", "OnGetDetailsFailed");
	AddStringParam("شناسه محصول");
	AddCondition(4, cf_trigger, "اگر پرداخت انجام شد", "purchase", "اگر پرداخت محصول <i>{0}</i> انجام شد", "هنگامی که عملیات پرداخت محصول با موفقیت انجام شود", "OnPurchaseSuccess");
	AddStringParam("شناسه محصول");
	AddCondition(5, cf_trigger, "اگر پرداخت انجام نشد", "purchase", "اگر پرداخت محصول <i>{0}</i> انجام نشد", "هنگامی که خطایی در عملیات پرداخت محصول رخ دهد", "OnPurchaseFailed");


//////////////////////////////////////
// Actions
	AddAction(0, af_none, "آماده سازی پلاگین", "iap", "آماده سازی پلاگین", "شروع عملیات آماده سازی پلاگین", "Initialize");
	AddVariadicParams("محصول {n}", "شناسه محصول {n} را وارد کنید");
	AddAction(1, af_none, "دریافت اطلاعات محصولات", "iap", "دریافت اطلاعات محصولات (<i>{...}</i>)", "شروع عملیات دریافت اطلاعات محصولات", "GetSkuDetails");
	AddStringParam("شناسه محصول");
	AddComboParamOption("خریدنی - مصرفی");
	AddComboParamOption("اشتراکی - غیرمصرفی");
	AddComboParam("نوع محصول");
	AddAction(2, af_none, "پرداخت محصول", "iap", "پرداخت محصول <i>{0}</i>", "شروع عملیات پرداخت محصول", "RequestPayment");
	
	
////////////////////////////////////////
// Expressions
	AddStringParam("ProductId");
	AddExpression(0, ef_return_string, "", "Etc", "PurchaseToken", "توکن خرید را در اختیارتان قرار می دهد");
	AddStringParam("ProductId");
	AddExpression(1, ef_return_string, "", "Etc", "PurchaseTime", "زمان خرید را در اختیارتان قرار می دهد");
	AddStringParam("ProductId");
	AddExpression(2, ef_return_string, "", "Etc", "PurchaseOrderId", "شماره سفارش را در اختیارتان قرار می دهد");
	AddStringParam("ProductId");
	AddExpression(3, ef_return_string, "", "Etc", "ProductTitle", "نام (عنوان) محصول را در اختیارتان قرار می دهد");
	AddStringParam("ProductId");
	AddExpression(4, ef_return_string, "", "Etc", "ProductPrice", "قیمت محصول را در اختیارتان قرار می دهد");
	AddStringParam("ProductId");
	AddExpression(5, ef_return_string, "", "Etc", "ProductDescription", "توضیحات محصول را در اختیارتان قرار می دهد");
	
ACESDone();

//////////////////////////////////////
// Properties
	var property_list = [
		new cr.Property(ept_text, "Public Key", "", "Enter Your App Public Key"),
		new cr.Property(ept_combo, "Market", "CafeBazaar", "Choose Your Market", "CafeBazaar|Myket|IranApps|Parshub|Cando|AvvalMarket|PlayStore")
	];

// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
    return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
    return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
    assert2(this instanceof arguments.callee, "Constructor called as a function");

    // Save the constructor parameters
    this.instance = instance;
    this.type = type;

    // Set the default property values from the property table
    this.properties = {};

    for (var i = 0; i < property_list.length; i++)
        this.properties[property_list[i].name] = property_list[i].initial_value;

    // Plugin-specific variables
    // this.myValue = 0...
}

// Called when inserted via Insert Object Dialog for the first time
IDEInstance.prototype.OnInserted = function()
{
}

// Called when double clicked in layout
IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called after a property has been changed in the properties bar
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

// For rendered objects to load fonts or textures
IDEInstance.prototype.OnRendererInit = function(renderer)
{
}

// Called to draw self in the editor if a layout object
IDEInstance.prototype.Draw = function(renderer)
{
}

// For rendered objects to release fonts or textures
IDEInstance.prototype.OnRendererReleased = function(renderer)
{
}

